package com.gic.enterprise.web.controller.wm;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URLEncoder;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.core.io.ClassPathResource;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 同步门店to微盟
 * @ClassName: WmStoreSyncController 
 * @Description:  
 * @author guojuxing 
 * @date 2020/5/8 11:19 AM 
 */
@RestController
@RequestMapping("/wm-store-sync")
public class WmStoreSyncController {
    private static final Logger LOGGER = LogManager.getLogger(WmStoreSyncController.class);


    /**
     *
     * @param request
     * @param response
     * @throws IOException
     */
    @RequestMapping("wm-store-import-template")
    public void wmStoreImportTemplate(HttpServletRequest request, HttpServletResponse response)
            throws IOException {
        ClassPathResource res = new ClassPathResource("exceltemplate/wm_store_import_template.xls");
        String userAgent = request.getHeader("User-Agent").toLowerCase();
        String fileName = "门店同步模板.xls";
        if (userAgent.contains("firefox")) {
            byte[] bytesName = fileName.getBytes("UTF-8");
            fileName = new String(bytesName, "ISO-8859-1");
            response.setHeader("content-disposition", "attachment;fileName=" + fileName);
        } else {
            response.setHeader("content-disposition", "attachment;fileName=" + URLEncoder.encode(fileName, "UTF-8"));
        }

        InputStream is = res.getInputStream();
        OutputStream out = response.getOutputStream();
        int bytes = 0;
        byte[] bufferOut = new byte[1024];
        while ((bytes = is.read(bufferOut)) != -1) {
            out.write(bufferOut, 0, bytes);
        }

        out.close();
        is.close();
    }
}
